/***************************************************************************

	FILE NAME: DRVR6812.H

	FILE DESCRIPTION:

   Header for the main part of the DM6812 driver

	PROJECT NAME:  DM6812/DM6912 DOS Driver

	DRIVER VERSION: 1.1

	COMPILER: Borland C++ 3.1

	TARGET: Real-Mode DOS

	Copyright 2003 RTD Embedded Technologies

***************************************************************************/

void ClearBoardIrq (void);
void ClearDIOChip (int AIOChip );
void ClearDIOIrq (int AIOChip );
void ClockDivisor (int ATimer , int ADivisor) ;
void ClockMode (int ATimer, int AMode ) ;
void DoneTimer(void);
void EnableBoardIrq (int AEnable ) ;
void EnableDIOIrq (int AIOPort , int AEnable);
void InitBoard (void) ;
void InitTimer (int ARate);
long ReadTC2(void);
int IrqStatus(void) ;
int isClockDone(void) ;
void LoadDIOBitDir (int AIOPort, int ADir7,int ADir6, int ADir5, int ADir4,
						  int ADir3,int ADir2,int ADir1,int ADir0) ;
void LoadDIOComp (int AIOChip,int AData);
void LoadDIOMask (int AIOChip,int AData) ;
void LoadDIOPortDir (int AIOPort,int ADir);
unsigned  ReadClock (int ATimer);
int ReadDIO (int AIOPort) ;
void SelectDIOClock (int AIOPort,int AClock);
void SetDIOIrqMode (int AIOChip,int AMode) ;
int TestTimer(void);
char* TitleString(void);
void WriteDIO (int AIOPort,int AData) ;


//=====================
// Interrupt handling.
//=====================

// Initialize the host interrupt and unmask the appropriate IRQ channel.
#ifdef __cplusplus
// Original interrupt storage C++ style
void InitHostIT(void interrupt (*IntVect) (...),char IRQ);
#else
// Original interrupt storage C style
void InitHostIT(void interrupt (*IntVect) (void),char IRQ);
#endif

void RestoreHostIT(char IRQchannel);   // Disable the IRQ channel and restore
                                       // the interrupt vector.

