/***************************************************************************

	FILE NAME: INTRUPT.C

	FILE DESCRIPTION: INTRUPT (Timer Interrupts)

   This program give a Example using intrupts with DM6812 DIO.
   This program Calls routines in DRVR6812.C

	PROJECT NAME: INTRUPT (Part of DM6812/6912 DOS Driver)

	DRIVER VERSION: 1.1

	COMPILER: Borland C++ 3.1

	TARGET: Real-Mode DOS

	Copyright 2003 RTD Embedded Technologies

***************************************************************************/

#include <conio.h>
#include "drvr6812.h"
// Constants for Mode Register Bit 5.
#define cSystem              0
#define cPROG                1
// Constants for Mode Register Bit 3.
#define cEVENT               0
#define cMATCH               1
// Constants for Direction Register
#define cINPUT               0
#define cOUTPUT              1
// Constants for Mode Register bit 4
#define cDISABLE            0
#define cENABLE             1

#define RATE               10
#define IRQ_CHANNEL			5

char IRQChannel;
volatile int DataOut;

#ifdef __cplusplus
 void interrupt NewISR(...)            // C++ style interrupt function
#else
 void interrupt NewISR(void)           // C style interrupt function
#endif
{
	DataOut++;
	if (DataOut > 255) DataOut = 0;
	WriteDIO(0,DataOut);        // write out DIO
	ClearBoardIrq();           // clear board Interrupt

	if ( IRQChannel >= 8 ) {    // VERY IMPORTANT !!!
	  outportb(0xA0, 0x20);    // End of interrupt command to the 2. controller
	}
	outportb(0x20, 0x20);      // End of interrupt command to the 1. controller
} //NewISR


void main(void){
													// Select Intrupt
	IRQChannel = IRQ_CHANNEL;
	clrscr();
	cprintf("DM6812 IRQ Test.\r\nHit Any Key To Exit.");
	gotoxy(30,6); cprintf("Write out to Port 0 ->");
	gotoxy(30,8); cprintf("READ from  PORT  2     4 ");
	InitBoard();                        // initialize board
	LoadDIOBitDir(0, cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT,  // set bit registers
							cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT);
	LoadDIOBitDir(2, cINPUT, cINPUT, cINPUT, cINPUT,
						  cINPUT, cINPUT, cINPUT, cINPUT);
	LoadDIOBitDir(4, cINPUT, cINPUT, cINPUT, cINPUT,
						  cINPUT, cINPUT, cINPUT, cINPUT);
	LoadDIOPortDir (1, cOUTPUT);        // set port registers
	LoadDIOPortDir (3, cINPUT);
	LoadDIOPortDir (5, cINPUT);
	InitTimer(RATE);
	ClearBoardIrq();                    // clear board Interrupt
	InitHostIT(NewISR,IRQChannel);      // set cpu interrupt
	EnableBoardIrq(cENABLE);            // enable boards intrrupt
	while(!kbhit()) {
		gotoxy(54,6); cprintf("%d    ",DataOut);
		gotoxy(47,9);
		cprintf("%d   %d    ",ReadDIO(2),ReadDIO(4)); // read from Port 2 and 4
	}
	getch();
	RestoreHostIT(IRQChannel);          // reset host interrupt
	EnableBoardIrq(cDISABLE);           // disable board interrupt
	DoneTimer();                        // reset timers
}