/***************************************************************************

	FILE NAME: MATCH.C

	FILE DESCRIPTION: MATCH (MATCH MODE)

	 This program will illustrate how to set up the DM6812 for Match Mode
   interrupts. Port2 is set as an output and Port0 is set as an input in
   Match Mode. For this program to operate Port2 and Port0 need to be
   connected together.

	PROJECT NAME: MATCH (Part of DM6812/6912 DOS Driver)

	DRIVER VERSION: 1.1

	COMPILER: Borland C++ 3.1

	TARGET: Real-Mode DOS

	Copyright 2003 RTD Embedded Technologies

***************************************************************************/


// This program calls routines in DRVR6812.C
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include "drvr6812.h"
// Constants for Mode Register Bit 5.
#define cSystem              0
#define cPROG                1
// Constants for Mode Register Bit 3.
#define cEVENT               0
#define cMATCH               1
// Constants for Direction Register
#define cINPUT               0
#define cOUTPUT              1
// Constants for Mode Register bit 4
#define cDISABLE            0
#define cENABLE             1

void main(void){
int i,j;
unsigned int DIOdata,Match_Status;
	clrscr();
	cprintf(" DM5408 Match Program");
	InitBoard();
	// set bit register
	LoadDIOBitDir(0, cINPUT, cINPUT, cINPUT, cINPUT,
							cINPUT, cINPUT, cINPUT, cINPUT);
	LoadDIOBitDir(2, cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT,
							cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT);
	LoadDIOBitDir(4, cINPUT, cINPUT, cINPUT, cINPUT,
							cINPUT, cINPUT, cINPUT, cINPUT);
	// set mode register to Macth mode
	SetDIOIrqMode(0, cMATCH);
	// enable DIO intrupte
	EnableDIOIrq(0, cENABLE);
	LoadDIOMask(0, 0);
	for (i=1;i <= 255;i++){
		// load the compare register
		LoadDIOComp( 0, i);
		// clear IRQ
		ClearDIOIrq( 0);
		gotoxy(20,10);
		cprintf("outport 2==> %d ",i);
			for (j =0;j <= 255;j++){
				if (kbhit()) {
					getch();
					_exit(0);     // if any key is hit exit
				}
				WriteDIO( 2, j);           // write out DIO 2
				DIOdata = ReadDIO(0);      // read DIO 0
				Match_Status = (IrqStatus()& 0xF); // read match status register
				gotoxy(40,10);
				cprintf("inport 0==> %d  Status==> %d   ",
						  DIOdata,Match_Status);
				if ((Match_Status ) == 1){
					delay(500);
					ClearDIOIrq( 0);
				};
			} // for
		}// for
	}// main


