/***************************************************************************

	FILE NAME: TESTDIG.C

	FILE DESCRIPTION: TESTDIG (DIGITAL I/O)

   This program will illustrate how to use the DM6812 digital I/O lines.
   This Program calls Routines in DRVR6812.C

	PROJECT NAME: TESTDIG (Part of DM6812/6912 DOS Driver)

	DRIVER VERSION: 1.1

	COMPILER: Borland C++ 3.1

	TARGET: Real-Mode DOS

	Copyright 2003 RTD Embedded Technologies

***************************************************************************/

#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include "drvr6812.h"
// Constants for Mode Register Bit 5.
#define cSystem              0
#define cPROG                1
// Constants for Mode Register Bit 3.
#define cEVENT               0
#define cMATCH               1
// Constants for Direction Register
#define cINPUT               0
#define cOUTPUT              1
// Constants for Mode Register bit 4
#define cDISABLE            0
#define cENABLE             1

void main (void){
int i;
	clrscr();
	InitBoard();

	LoadDIOBitDir(0, cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT,
							cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT);
	LoadDIOBitDir(2, cINPUT, cINPUT, cINPUT, cINPUT,
						  cINPUT, cINPUT, cINPUT, cINPUT);
	LoadDIOBitDir(4, cINPUT, cINPUT, cINPUT, cINPUT,
						  cINPUT, cINPUT, cINPUT, cINPUT);
	LoadDIOPortDir (1, cOUTPUT);
	LoadDIOPortDir (3, cINPUT);
	LoadDIOPortDir (5, cINPUT);
	clrscr();
	cprintf("DM6812  Test Program                               Real Time Devices");
	for (i = 0;i <= 255; i++){
	  WriteDIO( 0, 255 - i);
	  WriteDIO (1, i);
	  gotoxy(25,9);
	  cprintf("Out port 0   In Port 2  In Port 4");
	  gotoxy(25,10);
	  cprintf("  %d            %d        %d     ",
				 255 - i, ReadDIO(2),ReadDIO(4));

	  gotoxy(25,11);
	  cprintf("Out port 1   In Port 3  In Port 5");
	  gotoxy(25,12);
	  cprintf("  %d            %d        %d     ",
				 i, ReadDIO(3), ReadDIO(5));
	  delay(50);
		if (kbhit()) {
			getch();
			_exit(0);
		}
	}

  LoadDIOBitDir(0, cINPUT, cINPUT, cINPUT, cINPUT,
						 cINPUT, cINPUT, cINPUT, cINPUT);
  LoadDIOBitDir(2, cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT,
						 cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT);
  LoadDIOBitDir(4, cINPUT, cINPUT, cINPUT, cINPUT,
						 cINPUT, cINPUT, cINPUT, cINPUT);
  LoadDIOPortDir(1,cINPUT);
  LoadDIOPortDir(3,cOUTPUT);
  LoadDIOPortDir(5,cINPUT);
	for (i = 0 ;i <=255 ;i++) {
	  WriteDIO (2, 255 - i);
	  WriteDIO (3, i);
	  gotoxy(25,9);
	  cprintf("Out port 2   In Port 0  In Port 4");
	  gotoxy(25,10);
	  cprintf("  %d            %d        %d     ",
				  255 - i, ReadDIO(0), ReadDIO(4));


	  gotoxy(25,11);
	  cprintf("Out port 3   In Port 1  In Port 5");
	  gotoxy(25,12);
	  cprintf("  %d            %d        %d     ",
				  i, ReadDIO(1), ReadDIO(5));
	  delay(50);
		if (kbhit()) {
			getch();
			_exit(0);
		}
	}

  LoadDIOBitDir(0, cINPUT, cINPUT, cINPUT, cINPUT,
						 cINPUT, cINPUT, cINPUT, cINPUT);
  LoadDIOBitDir(2, cINPUT, cINPUT, cINPUT, cINPUT,
						  cINPUT, cINPUT, cINPUT, cINPUT);
  LoadDIOBitDir(4, cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT,
						 cOUTPUT, cOUTPUT, cOUTPUT, cOUTPUT);
  LoadDIOPortDir( 1, cINPUT);
  LoadDIOPortDir (3, cINPUT);
  LoadDIOPortDir (5, cOUTPUT);
	for (i = 0 ;i <=255 ;i++) {
	  WriteDIO (4, 255 - i);
	  WriteDIO (5, i );
	  gotoxy(25,9);
	  cprintf("Out port 4   In Port 0  In Port 2");
	  gotoxy(25,10);
	  cprintf("  %d            %d        %d     ",
				 255 - i,  ReadDIO(0),ReadDIO(2));

	  gotoxy(25,11);
	  cprintf("Out port 5   In Port 1  In Port 3");
	  gotoxy(25,12);
	  cprintf("  %d            %d        %d     ",
					i,  ReadDIO(1),ReadDIO(3));
	  delay(50);
		if (kbhit()) {
			getch();
			_exit(0);
		}
	}

}



