/***************************************************************************

	FILE NAME: TIMERS.C

	FILE DESCRIPTION: TIMERS (User timers )

   This program will illustrate how to program the 8254 timer on the
   DM6812. Timer 0 and 1 are programmed to generate a 10 Hz pulse train.
   Timer 2 is used to count these pulses. The result is converted into
   seconds and printed on the screen. Make sure the jumpers for connecting
   the output from Timer 0 to the input of Timer 1  and the output from
   Timer 1 to the input of Timer 2 are in place.

	PROJECT NAME: TIMERS (Part of DM6812/6912 DOS Driver)

	DRIVER VERSION: 1.1

	COMPILER: Borland C++ 3.1

	TARGET: Real-Mode DOS

	Copyright 2003 RTD Embedded Technologies

***************************************************************************/
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include "drvr6812.h"
// Constants for Mode Register Bit 5.
#define cSystem              0
#define cPROG                1
// Constants for Mode Register Bit 3.
#define cEVENT               0
#define cMATCH               1
// Constants for Direction Register
#define cINPUT               0
#define cOUTPUT              1
// Constants for Mode Register bit 4
#define cDISABLE            0
#define cENABLE             1

#define RATE                5
void main(void){

unsigned Minutes;
float    Seconds;
	clrscr();
	InitBoard();
	InitTimer(RATE);
	cprintf("DM6812 Timer Test.\r\nHit Any Key To Exit.");
	gotoxy(30,8); cprintf("Time ->");
	Minutes = 0;
	Seconds = 0;
	while(!kbhit()) {
		while ( !isClockDone() );      // Wait until counter overrun.
		Seconds++;                  // Increment clock counter.
		if (Seconds/RATE == 60){
			Minutes++;
			Seconds = 0;
		}
		gotoxy(40, 8);
		cprintf(" %d:%2.1f    ",Minutes,Seconds/RATE);
													// Display time.
	}
	getch();
	DoneTimer();
}

